﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.GridControls;
using System.Data;
using System.Web.Services;
using System.Web.Script.Services;
using System.Web.Script.Serialization;

namespace Mfs.Invest.InvestWeb.PeerReview.Admin
{
    public partial class QuestionaresReviewerWillSee : AdminPeerReviewBasePage
    {
        private DataBase.ReviewDB _db = new DataBase.ReviewDB();

        protected delegate void AddDelegate(string sessionType, string reviewType, string role);
        protected delegate void DeleteDelegate(string sessionType, string reviewType, string role);

        #region Ajax Calls
        [WebMethod]
        public static void ModifyAssignedTypes(string sessionType, string typeOfUser , string role, string[] oldValues, string[] newValues)
        {
            DataBase.ReviewDB _dbLogic = new DataBase.ReviewDB();
            AddDelegate add;
            DeleteDelegate delete;

            if (typeOfUser == "Reviewer")
            {
                add = _dbLogic.InsertPeerReviewerXRef;
                delete = _dbLogic.DeletePeerReviewerXRef;
            }
            else
            {
                add = _dbLogic.InsertPeerRevieweeXRef;
                delete = _dbLogic.DeletePeerRevieweeXRef;
            }

            // Add new items
            foreach (string reviewType in newValues)
            {
                if (!oldValues.Contains(reviewType))
                {
                    add(sessionType, reviewType, role); 
                }
            }

            // Delete removed items.
            foreach (string reviewType in oldValues)
            {
                if (!newValues.Contains(reviewType))
                {
                    delete(sessionType, reviewType, role);
                }
            }            
        }
        [WebMethod]
        public static Business.Objects.Option[] GetAssignedReviewTypes(string sessionType,string typeOfUser, string role)
        {
            DataBase.ReviewDB _dbLogic = new DataBase.ReviewDB();

            //            JavaScriptSerializer js;
            System.Data.DataRow row;
            Business.Objects.Option []  options;
            System.Data.DataTable assignedReviewTypes = null;

            if (typeOfUser == "Reviewer")
            {
                assignedReviewTypes = _dbLogic.GetPeerReviewerXRefs(sessionType,role);
            }
            else
            {
                assignedReviewTypes = _dbLogic.GetPeerRevieweeXRefs(sessionType,role);
            }
            options = new Business.Objects.Option[assignedReviewTypes.Rows.Count];

            for (int i = 0; i <= assignedReviewTypes.Rows.Count - 1; i++)
            {
                row = assignedReviewTypes.Rows[i];
                options[i] = new Business.Objects.Option(row["NAME"].ToString().Replace("'", "\\'"), row["REVIEW_TYPE"].ToString());
            }

            //            js = new JavaScriptSerializer(new Utility.SysSerializationTypeResolver());

            //          return js.Serialize(brokers);

            return options;
        }
        [WebMethod]
        public static Business.Objects.Option[] GetReviewTypesForSessionType(string sessionType)
        {
            DataBase.ReviewDB _dbLogic = new DataBase.ReviewDB();

            System.Data.DataRow row;
            Business.Objects.Option[] options;
            System.Data.DataTable reviewTypes = null;

            reviewTypes = _dbLogic.GetReviewTypesForSessionType(sessionType);

            options = new Business.Objects.Option[reviewTypes.Rows.Count];

            for (int i = 0; i <= reviewTypes.Rows.Count - 1; i++)
            {
                row = reviewTypes.Rows[i];
                options[i] = new Business.Objects.Option(row["NAME"].ToString().Replace("'", "\\'"), row["REVIEW_TYPE"].ToString());
            }

            return options;

        }
        #endregion

        #region Page Events
        protected override void PageLoadEvent(object sender, System.EventArgs e)
        {
            base.PageLoadEvent(sender, e);

            
            wdgCrossReference.DataSource = _db.GetRoles();

            if (!this.IsPostBack)
            {
                
                Sorting behavior = this.wdgCrossReference.Behaviors.Sorting;
                behavior.SortedColumns.Add(this.wdgCrossReference.Columns["ROLE_NAME"],
                                           Infragistics.Web.UI.SortDirection.Ascending);

                hdnUserType.Value = Request.QueryString.Get("UserType");
                if (hdnUserType.Value == "Reviewer")
                {
                    dvHeader.InnerText = "Questionares a Reviewer will see";
                }
                else
                {
                    dvHeader.InnerText = "Questionares a person will appear on";
                }
                lstReviewTypes.DataBind();
            }

        }
        #endregion

        protected void wdgCrossReference_RowSelectionChanged(object sender, SelectedRowEventArgs e)
        {
            wdwError.Visible = true;
        }

        protected void lstReviewTypes_DataBinding(object sender, EventArgs e)
        {
            lstReviewTypes.DataSource = _db.GetReviewTypesForSessionType(wddSessionType.SelectedValue);
        }

    }
}